<?php

class WPML_HyperDB {

	/** @var wpdb */
	private $wpdb;

	public function __construct( $wpdb ) {
		$this->wpdb = $wpdb;
		$this->init();
	}

	protected function init() {
		add_action( 'wpml_hyperdb_has_requirements', array( $this, 'load_hyperdb_filter' ) );
		new WPML_HyperDB_Requirements();
	}

	public function load_hyperdb_filter() {
		add_filter( 'query', array( $this, 'hyperdb_query_filter' ) );
	}

	public function hyperdb_query_filter( $query ) {
		if ( preg_match( '/^\s*(insert|update)\s.+\s*(icl_)/i', $query ) ) {
			$this->wpdb->set_sql_mode();
		}

		return $query;
	}
}
